## endless-sky 0.10.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21..3.25)

include(CMakeDependentOption)
option(ES_USE_VCPKG "Use vcpkg to get dependencies." ON)
cmake_dependent_option(ES_GLES "Build the game with OpenGL ES" OFF UNIX OFF)
cmake_dependent_option(ES_FLATPAK "Build the game inside the Flatpak runtime" OFF UNIX OFF)
cmake_dependent_option(ES_STEAM "Build the game for the Steam Linux runtime" OFF UNIX OFF)
cmake_dependent_option(ES_USE_SYSTEM_LIBRARIES "Use system libraries instead of the vcpkg ones." ON UNIX OFF)
cmake_dependent_option(ES_CREATE_BUNDLE "Create a Bundle instead of an executable. Not suitable for development purposes." OFF APPLE OFF)

# Support Debug and Release configurations.
set(CMAKE_CONFIGURATION_TYPES "Debug" "Release" CACHE STRING "" FORCE)

# Use C++17 without any compiler specific extensions.
set(CMAKE_CXX_STANDARD 17 CACHE STRING "")
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
# Use LTO for Release builds only.
set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_DEBUG FALSE)
set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_RELEASE TRUE)
# On Linux use relative RPATH.
set(CMAKE_BUILD_RPATH_USE_ORIGIN ON)

# Setup vcpkg.
if(ES_USE_VCPKG)
	set(CMAKE_TOOLCHAIN_FILE "${CMAKE_CURRENT_SOURCE_DIR}/vcpkg/scripts/buildsystems/vcpkg.cmake"
		CACHE STRING "Vcpkg toolchain file")
	# No need to bootstrap vcpkg if the toolchain file is explictly provided.
	if(CMAKE_TOOLCHAIN_FILE STREQUAL "${CMAKE_CURRENT_SOURCE_DIR}/vcpkg/scripts/buildsystems/vcpkg.cmake")
		include(utils/vcpkg_bootstrap.cmake)
		x_vcpkg_bootstrap()
	endif()

	set(VCPKG_BOOTSTRAP_OPTIONS "-disableMetrics")
	set(VCPKG_INSTALL_OPTIONS "--no-print-usage")
	set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)
	set(X_VCPKG_APPLOCAL_DEPS_INSTALL ON)
endif()

if(NOT ES_USE_SYSTEM_LIBRARIES)
	# Tell vcpkg to use the required system libraries.
	list(APPEND VCPKG_MANIFEST_FEATURES "system-libs")
endif()

# Tell vcpkg to use system libraries that are missing on the respective platform.
if(ES_FLATPAK)
	list(APPEND VCPKG_MANIFEST_FEATURES "flatpak-libs")
elseif(ES_STEAM)
	list(APPEND VCPKG_MANIFEST_FEATURES "steam-libs")
elseif(APPLE)
	list(APPEND VCPKG_MANIFEST_FEATURES "macos-libs")
endif()

# Various helpful options for IDEs.
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT EndlessSky)
set(CMAKE_VS_JUST_MY_CODE_DEBUGGING ON)

project("Endless Sky" VERSION 0.10.6
	DESCRIPTION "Space exploration, trading, and combat game."
	HOMEPAGE_URL https://endless-sky.github.io/
	LANGUAGES CXX)

# Find the needed library dependencies.
find_package(SDL2 CONFIG REQUIRED)
find_package(PNG REQUIRED)
find_package(JPEG REQUIRED)
if(NOT APPLE)
	find_package(GLEW REQUIRED)
endif()

# Only very new versions of OpenAL provide a config package, so try to find it manually.
find_package(OpenAL CONFIG QUIET)
if(NOT OpenAL_FOUND)
	find_library(OPENAL openal REQUIRED)
	add_library(OpenAL UNKNOWN IMPORTED)
	add_library(OpenAL::OpenAL ALIAS OpenAL)
	set_target_properties(OpenAL PROPERTIES IMPORTED_LOCATION "${OPENAL}")
endif()

# libmad doesn't provide native cmake support.
find_path(LIBMAD_INCLUDE_DIR mad.h)
find_library(LIBMAD_LIB_DEBUG NAMES mad libmad NAMES_PER_DIR PATHS "${_VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/debug/lib")
find_library(LIBMAD_LIB_RELEASE NAMES mad libmad NAMES_PER_DIR PATHS "${_VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/lib")

# Find the MinGW runtime DLLs.
if(MINGW AND WIN32)
	# On Windows copy the MinGW runtime DLLs to the output folder as well.
	# This is to avoid the situation where a user has other MinGW runtime DLLs
	# in their PATH that are incompatible with the MinGW used to compile ES.
	get_filename_component(PARENT_DIR "${CMAKE_CXX_COMPILER}" DIRECTORY)
	get_filename_component(MINGW_RUNTIME_DIR "${PARENT_DIR}" DIRECTORY)

	# MinGW doesn't have seh exceptions support for 32-bit Windows unfortunately,
	# and requires libgcc_s_dw2-1.dll instead of libgcc_s_seh-1.dll. There's no
	# perfect way to figure out which one to copy, so we simply copy both.
	# The executable will choose the correct DLL anyways.
	foreach(lib "stdc++-6" "winpthread-1" "gcc_s_seh-1" "gcc_s_dw2-1")
		file(GLOB_RECURSE FILE_PATH "${MINGW_RUNTIME_DIR}/lib${lib}.dll")
		if(FILE_PATH)
			list(APPEND MINGW_RUNTIME "${FILE_PATH}")
		endif()
	endforeach()
endif()

# Add the library target.
add_subdirectory(source)

# Create an interface library that contains common libraries for the game and unit tests.
add_library(ExternalLibraries INTERFACE)
target_link_libraries(EndlessSkyLib PUBLIC ExternalLibraries)

# The 'mingw32' lib needs to be linked first.
if(MINGW)
	target_link_libraries(ExternalLibraries INTERFACE mingw32)
endif()

# Link with the general libraries.
target_link_libraries(ExternalLibraries INTERFACE SDL2::SDL2 PNG::PNG JPEG::JPEG OpenAL::OpenAL
	"$<IF:$<CONFIG:Debug>,${LIBMAD_LIB_DEBUG},${LIBMAD_LIB_RELEASE}>")

# Link the needed OS-specific dependencies, if any.
if(WIN32)
	target_link_libraries(ExternalLibraries INTERFACE rpcrt4 Winmm)
else()
	target_link_libraries(ExternalLibraries INTERFACE pthread)
endif()

# Link with the UUID library, which is different for each OS.
if(UNIX)
	if(APPLE)
		find_library(UUID_LIB NAMES System PATHS /lib /usr/lib /usr/local/lib)
		find_path(UUID_INCLUDE uuid/uuid.h /usr/local/include /usr/include)
		target_link_libraries(ExternalLibraries INTERFACE "${UUID_LIB}")
		target_include_directories(ExternalLibraries INTERFACE "${UUID_INCLUDE}")
	elseif(ES_USE_SYSTEM_LIBRARIES)
		find_library(UUID_LIB uuid)
		target_link_libraries(ExternalLibraries INTERFACE "${UUID_LIB}")
	else()
		find_package(unofficial-libuuid CONFIG REQUIRED)
		target_link_libraries(ExternalLibraries INTERFACE unofficial::UUID::uuid)
	endif()
endif()

# Link with OpenGL or OpenGL ES.
if(ES_GLES)
	find_package(OpenGL REQUIRED OpenGL EGL)
	target_link_libraries(ExternalLibraries INTERFACE OpenGL::OpenGL OpenGL::EGL)
	target_compile_definitions(EndlessSkyLib PUBLIC ES_GLES)
else()
	# The Steam runtime can't rely on GLVND being available, so link against the legacy interface.
	if(ES_STEAM)
		set(OpenGL_GL_PREFERENCE "LEGACY")
	endif()

	find_package(OpenGL REQUIRED)
	target_link_libraries(ExternalLibraries INTERFACE OpenGL::GL)

	if(APPLE)
		# Apple deprecated OpenGL in MacOS 10.14, but we don't care.
		target_compile_definitions(EndlessSkyLib PUBLIC GL_SILENCE_DEPRECATION)
	else()
		# GLEW is only needed on Linux and Windows.
		target_link_libraries(ExternalLibraries INTERFACE GLEW::GLEW)
	endif()
endif()

# Setup for the testing frameworks.
include(CTest)
if(BUILD_TESTING)
	add_subdirectory(tests)
endif()

# Create game target.
if(APPLE AND ES_CREATE_BUNDLE)
	add_executable(EndlessSky MACOSX_BUNDLE source/main.cpp)

	# MacOS bundles are a bit special and need every resource specified when
	# creating the executable.
	# NOTE: This means that a reconfigure is needed if any assets are added/removed!
	foreach(folder "data" "images" "sounds")
		file(GLOB_RECURSE RESOURCES "${CMAKE_CURRENT_SOURCE_DIR}/${folder}/*")
		target_sources(EndlessSky PRIVATE "${RESOURCES}")

		foreach(FILE ${RESOURCES})
			# Get the relative path from the root folder to the current file.
			file(RELATIVE_PATH NEW_FILE "${CMAKE_CURRENT_SOURCE_DIR}" "${FILE}")
			# Get the parent directory for the new location.
			get_filename_component(FILE_PATH "${NEW_FILE}" DIRECTORY)

			# Resources belong under Resources/.
			set_source_files_properties("${FILE}" PROPERTIES MACOSX_PACKAGE_LOCATION "Resources/${FILE_PATH}")
		endforeach()
	endforeach()

	# Create the icns file, required for the bundle icon.
	add_custom_command(
		OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/icons/endless-sky.icns"
		COMMAND iconutil -c icns -o icons/endless-sky.icns icons/endless-sky.iconset
		DEPENDS icons/endless-sky.iconset/icon_16x16.png icons/endless-sky.iconset/icon_16x16@2x.png
			icons/endless-sky.iconset/icon_32x32.png icons/endless-sky.iconset/icon_32x32@2x.png
			icons/endless-sky.iconset/icon_128x128.png icons/endless-sky.iconset/icon_128x128@2x.png
			icons/endless-sky.iconset/icon_256x256.png icons/endless-sky.iconset/icon_256x256@2x.png
			icons/endless-sky.iconset/icon_512x512.png icons/endless-sky.iconset/icon_512x512@2x.png
		WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}" VERBATIM)

	# Now do the same to standalone files.
	foreach(file "license.txt" "keys.txt" "credits.txt" "copyright" "changelog" "icons/endless-sky.icns")
		target_sources(EndlessSky PRIVATE ${file})
		set_source_files_properties(${file} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources/")
	endforeach()

	# Add plist to bundle.
	set_target_properties(EndlessSky PROPERTIES
		MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_LIST_DIR}/resources/EndlessSky-Info.plist"
		XCODE_ATTRIBUTE_ASSETCATALOG_COMPILER_APPICON_NAME endless-sky)
	set_target_properties(EndlessSky PROPERTIES OUTPUT_NAME "Endless Sky")
elseif(WIN32)
	add_executable(EndlessSky WIN32 source/main.cpp source/WinApp.rc)
	set_target_properties(EndlessSky PROPERTIES OUTPUT_NAME "Endless Sky")
else()
	add_executable(EndlessSky source/main.cpp)
	set_target_properties(EndlessSky PROPERTIES OUTPUT_NAME "endless-sky")
endif()

# Link with the library dependencies.
target_link_libraries(EndlessSky PRIVATE ExternalLibraries EndlessSkyLib $<TARGET_NAME_IF_EXISTS:SDL2::SDL2main>)

# Copy the MinGW runtime DLLs if necessary.
if(MINGW AND WIN32)
	foreach(FILE_PATH ${MINGW_RUNTIME})
		add_custom_command(TARGET EndlessSky POST_BUILD
			COMMAND "${CMAKE_COMMAND}" -E copy_if_different "${FILE_PATH}" "$<TARGET_FILE_DIR:EndlessSky>"
			COMMAND_EXPAND_LISTS VERBATIM)

		# Add an install rule for this DLLs, so that it is also included when installing.
		install(FILES ${FILE_PATH} DESTINATION .)
	endforeach()
endif()

# Installation configurations.
if(APPLE)
	install(TARGETS EndlessSky CONFIGURATIONS Release BUNDLE DESTINATION .)
elseif(WIN32)
	# Install the binary.
	install(TARGETS EndlessSky CONFIGURATIONS Release RUNTIME DESTINATION .)

	# The MinGW DLLs needed were already installed above, and vcpkg installs the library DLLs.

	# Install the resource files.
	install(DIRECTORY data DESTINATION .)
	install(DIRECTORY images DESTINATION .)
	install(DIRECTORY sounds DESTINATION .)
	install(FILES credits.txt DESTINATION .)
	install(FILES keys.txt DESTINATION .)
	install(FILES copyright DESTINATION .)
	install(FILES changelog DESTINATION .)
	install(FILES license.txt DESTINATION .)
elseif(UNIX)
	# Install the binary.
	install(TARGETS EndlessSky CONFIGURATIONS Release RUNTIME DESTINATION games)

	# Install the desktop file.
	install(FILES io.github.endless_sky.endless_sky.desktop DESTINATION share/applications)

	# Install app center metadata.
	install(FILES io.github.endless_sky.endless_sky.appdata.xml DESTINATION share/metainfo)

	# Install icons, keeping track of all the paths.
	# Most Ubuntu apps supply 16, 22, 24, 32, 48, and 256, and sometimes others.
	foreach(size "16x16" "22x22" "24x24" "32x32" "48x48" "128x128" "256x256" "512x512")
		install(FILES "icons/icon_${size}.png" DESTINATION "share/icons/hicolor/${size}/apps"
			RENAME endless-sky.png)
	endforeach()

	# Gzip and install man file.
	add_custom_command(
		OUTPUT endless-sky.6.gz
		COMMAND gzip -c endless-sky.6 > ${CMAKE_CURRENT_BINARY_DIR}/endless-sky.6.gz
		DEPENDS endless-sky.6
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		VERBATIM)
	target_sources(EndlessSky PRIVATE endless-sky.6.gz)
	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/endless-sky.6.gz DESTINATION share/man/man6)

	# Install the resource files.
	install(DIRECTORY data DESTINATION share/games/endless-sky)
	install(DIRECTORY images DESTINATION share/games/endless-sky)
	install(DIRECTORY sounds DESTINATION share/games/endless-sky)
	install(FILES credits.txt DESTINATION share/games/endless-sky)
	install(FILES keys.txt DESTINATION share/games/endless-sky)
	install(FILES copyright DESTINATION share/doc/endless-sky)
	install(FILES changelog DESTINATION share/doc/endless-sky)

=== source/CMakeLists.txt ===
add_library(EndlessSkyLib OBJECT)

# Set the appropriate compiler flags.
target_include_directories(EndlessSkyLib PUBLIC "${LIBMAD_INCLUDE_DIR}")
if(MSVC)
	target_compile_options(EndlessSkyLib PUBLIC "/W3" "/permissive-" "/sdl" "/GR-" "/analyze-"
		"-Wno-nonportable-include-path" "$<$<CONFIG:Release>:/Gy;/Oi>")
	target_compile_definitions(EndlessSkyLib PUBLIC "_UNICODE" "UNICODE")
else()
	target_compile_options(EndlessSkyLib PUBLIC
		"-Wall" "-pedantic-errors" "-Wold-style-cast" "-fno-rtti")
endif()

# Every source file (and header file) should be listed here, except main.cpp.
# If you add a new file, add it to this list.
target_sources(EndlessSkyLib PRIVATE
	AI.cpp
	AI.h
	Account.cpp
	Account.h
	AlertLabel.cpp
	AlertLabel.h
	AmmoDisplay.cpp
	AmmoDisplay.h
	Angle.cpp
	Angle.h
	Animate.h
	Armament.cpp
	Armament.h
	AsteroidField.cpp
	AsteroidField.h
	Audio.cpp
	Audio.h
	BankPanel.cpp
	BankPanel.h
	BatchDrawList.cpp
	BatchDrawList.h
	BatchShader.cpp
	BatchShader.h
	Bitset.cpp
	Bitset.h
	BoardingPanel.cpp
	BoardingPanel.h
	Body.cpp
	Body.h
	CaptureOdds.cpp
	CaptureOdds.h
	CargoHold.cpp
	CargoHold.h
	CategoryList.cpp
	CategoryList.h
	CategoryTypes.h
	ClickZone.h
	Collision.cpp
	Collision.h
	CollisionSet.cpp
	CollisionSet.h
	CollisionType.h
	Color.cpp
	Color.h
	Command.cpp
	Command.h
	ConditionSet.cpp
	ConditionSet.h
	ConditionsStore.cpp
	ConditionsStore.h
	Conversation.cpp
	Conversation.h
	ConversationPanel.cpp
	ConversationPanel.h
	CoreStartData.cpp
	CoreStartData.h
	DamageDealt.h
	DamageProfile.cpp
	DamageProfile.h
	DataFile.cpp
	DataFile.h
	DataNode.cpp
	DataNode.h
	DataWriter.cpp
	DataWriter.h
	Date.cpp
	Date.h
	Depreciation.cpp
	Depreciation.h
	Dialog.cpp
	Dialog.h
	Dictionary.cpp
	Dictionary.h
	DistanceCalculationSettings.h
	DistanceCalculationSettings.cpp
	DistanceMap.cpp
	DistanceMap.h
	Distribution.cpp
	Distribution.h
	DrawList.cpp
	DrawList.h
	Effect.cpp
	Effect.h
	Engine.cpp
	Engine.h
	EsUuid.cpp
	EsUuid.h
	EscortDisplay.cpp
	EscortDisplay.h
	ExclusiveItem.h
	File.cpp
	File.h
	Files.cpp
	Files.h
	FillShader.cpp
	FillShader.h
	FireCommand.cpp
	FireCommand.h
	Fleet.cpp
	Fleet.h
	FleetCargo.cpp
	FleetCargo.h
	Flotsam.cpp
	Flotsam.h
	FogShader.cpp
	FogShader.h
	FormationPattern.cpp
	FormationPattern.h
	FrameTimer.cpp
	FrameTimer.h
	Galaxy.cpp
	Galaxy.h
	GameAction.cpp
	GameAction.h
	GameData.cpp
	GameData.h
	GameEvent.cpp
	GameEvent.h
	GameLoadingPanel.cpp
	GameLoadingPanel.h
	Gamerules.cpp
	Gamerules.h
	GameWindow.cpp
	GameWindow.h
	Government.cpp
	Government.h
	HailPanel.cpp
	HailPanel.h
	Hardpoint.cpp
	Hardpoint.h
	Hazard.cpp
	Hazard.h
	HiringPanel.cpp
	HiringPanel.h
	ImageBuffer.cpp
	ImageBuffer.h
	ImageSet.cpp
	ImageSet.h
	InfoPanelState.cpp
	InfoPanelState.h
	Information.cpp
	Information.h
	Interface.cpp
	Interface.h
	ItemInfoDisplay.cpp
	ItemInfoDisplay.h
	JumpTypes.h
	Logger.cpp
	Logger.h
	LineShader.cpp
	LineShader.h
	LoadPanel.cpp
	LoadPanel.h
	LocationFilter.cpp
	LocationFilter.h
	LogbookPanel.cpp
	LogbookPanel.h
	MainPanel.cpp
	MainPanel.h
	MapDetailPanel.cpp
	MapDetailPanel.h
	MapOutfitterPanel.cpp
	MapOutfitterPanel.h
	MapPanel.cpp
	MapPanel.h
	MapPlanetCard.cpp
	MapPlanetCard.h
	MapSalesPanel.cpp
	MapSalesPanel.h
	MapShipyardPanel.cpp
	MapShipyardPanel.h
	Mask.cpp
	Mask.h
	MaskManager.cpp
	MaskManager.h
	MenuAnimationPanel.cpp
	MenuAnimationPanel.h
	MenuPanel.cpp
	MenuPanel.h
	MessageLogPanel.cpp
	MessageLogPanel.h
	Messages.cpp
	Messages.h
	Minable.cpp
	Minable.h
	Mission.cpp
	Mission.h
	MissionAction.cpp
	MissionAction.h
	MissionPanel.cpp
	MissionPanel.h
	Mortgage.cpp
	Mortgage.h
	Music.cpp
	Music.h
	NPC.cpp
	NPC.h
	NPCAction.cpp
	NPCAction.h
	News.cpp
	News.h
	Outfit.cpp
	Outfit.h
	OutfitInfoDisplay.cpp
	OutfitInfoDisplay.h
	OutfitterPanel.cpp
	OutfitterPanel.h
	OutlineShader.cpp
	OutlineShader.h
	Panel.cpp
	Panel.h
	Person.cpp
	Person.h
	Personality.cpp
	Personality.h
	Phrase.cpp
	Phrase.h
	Planet.cpp
	Planet.h
	PlanetLabel.cpp
	PlanetLabel.h
	PlanetPanel.cpp
	PlanetPanel.h
	PlayerInfo.cpp
	PlayerInfo.h
	PlayerInfoPanel.cpp
	PlayerInfoPanel.h
	Plugins.cpp
	Plugins.h
	Point.cpp
	Point.h
	PointerShader.cpp
	PointerShader.h
	Politics.cpp
	Politics.h
	Port.cpp
	Port.h
	Preferences.cpp
	Preferences.h
	PreferencesPanel.cpp
	PreferencesPanel.h
	PrintData.cpp
	PrintData.h
	Projectile.cpp
	Projectile.h
	Radar.cpp
	Radar.h
	RaidFleet.cpp
	RaidFleet.h
	Random.cpp
	Random.h
	RandomEvent.h
	Rectangle.cpp
	Rectangle.h
	RenderBuffer.cpp
	RenderBuffer.h
	RingShader.cpp
	RingShader.h
	Sale.h
	SavedGame.cpp
	SavedGame.h
	Screen.cpp
	Screen.h
	ScrollVar.h
	Set.h
	Shader.cpp
	Shader.h
	Ship.cpp
	Ship.h
	ShipEvent.cpp
	ShipEvent.h
	ShipInfoDisplay.cpp
	ShipInfoDisplay.h
	ShipInfoPanel.cpp
	ShipInfoPanel.h
	ShipJumpNavigation.cpp
	ShipJumpNavigation.h
	ShipManager.cpp
	ShipManager.h
	ShipyardPanel.cpp
	ShipyardPanel.h
	ShopPanel.cpp
	ShopPanel.h
	Sound.cpp
	Sound.h
	SpaceportPanel.cpp
	SpaceportPanel.h
	Sprite.cpp
	Sprite.h
	SpriteQueue.cpp
	SpriteQueue.h
	SpriteSet.cpp
	SpriteSet.h
	SpriteShader.cpp
	SpriteShader.h
	StarField.cpp
	StarField.h
	StartConditions.cpp
	StartConditions.h
	StartConditionsPanel.cpp
	StartConditionsPanel.h
	StellarObject.cpp
	StellarObject.h
	System.cpp
	System.h
	SystemEntry.h
	Test.cpp
	Test.h
	TestContext.cpp
	TestContext.h
	TestData.cpp
	TestData.h
	TextReplacements.cpp
	TextReplacements.h
	Trade.cpp
	Trade.h
	TradingPanel.cpp
	TradingPanel.h
	UI.cpp
	UI.h
	UniverseObjects.cpp
	UniverseObjects.h
	Variant.cpp
	Variant.h
	Visual.cpp
	Visual.h
	Weapon.cpp
	Weapon.h
	Weather.cpp
	Weather.h
	WeightedList.h
	Wormhole.cpp
	Wormhole.h
	WormholeStrategy.h
	opengl.cpp
	opengl.h
	pi.h
	shift.h
	comparators/ByGivenOrder.h
	comparators/ByName.h
	comparators/BySeriesAndIndex.h
	ship/ShipAICache.cpp
	ship/ShipAICache.h
	text/DisplayText.cpp
	text/DisplayText.h
	text/Font.cpp
	text/Font.h
	text/FontSet.cpp
	text/FontSet.h
	text/Format.cpp
	text/Format.h
	text/Table.cpp
	text/Table.h
	text/Utf8.cpp
	text/Utf8.h
	text/WrappedText.cpp
	text/WrappedText.h
	text/alignment.hpp
	text/layout.hpp
	text/truncate.hpp
)

=== tests/CMakeLists.txt ===
add_executable(EndlessSkyTests)
if(UNIX AND NOT APPLE)
	set_target_properties(EndlessSkyTests PROPERTIES OUTPUT_NAME "endless-sky-tests")
endif()

if(NOT MSVC)
	target_compile_options(EndlessSkyTests PUBLIC
		"-Wall" "-pedantic-errors" "-Wold-style-cast" "-fno-rtti")
endif()

# Every source file (and header file) should be listed here.
# If you add a new file, add it to this list.
target_sources(EndlessSkyTests PRIVATE
	unit/include/catch.hpp
	unit/include/datanode-factory.h
	unit/include/es-test.hpp
	unit/include/output-capture.hpp
	unit/src/comparators/test_byGivenOrder.cpp
	unit/src/comparators/test_byName.cpp
	unit/src/helpers/datanode-factory.cpp
	unit/src/test_account.cpp
	unit/src/test_angle.cpp
	unit/src/test_bitset.cpp
	unit/src/test_categoryList.cpp
	unit/src/test_conditionSet.cpp
	unit/src/test_conditionsStore.cpp
	unit/src/test_datafile.cpp
	unit/src/test_datanode.cpp
	unit/src/test_dictionary.cpp
	unit/src/test_distance_calculation_settings.cpp
	unit/src/test_esuuid.cpp
	unit/src/test_exclusiveItem.cpp
	unit/src/test_firecommand.cpp
	unit/src/test_formationPattern.cpp
	unit/src/test_main.cpp
	unit/src/test_point.cpp
	unit/src/test_random.cpp
	unit/src/test_scrollVar.cpp
	unit/src/test_set.cpp
	unit/src/test_ship.cpp
	unit/src/test_template.txt
	unit/src/test_weightedList.cpp
	unit/src/text/test_alignment.cpp
	unit/src/text/test_displaytext.cpp
	unit/src/text/test_format.cpp
	unit/src/text/test_layout.cpp
	unit/src/text/test_truncate.cpp
)

list(APPEND INTEGRATION_TESTS
	integration/config/plugins/integration-tests/data/tests/tests_afterburn_flight.txt
	integration/config/plugins/integration-tests/data/tests/tests_capture_override.txt
	integration/config/plugins/integration-tests/data/tests/tests_common.txt
	integration/config/plugins/integration-tests/data/tests/tests_conditional_choice.txt
	integration/config/plugins/integration-tests/data/tests/tests_disown.txt
	integration/config/plugins/integration-tests/data/tests/tests_flagship_attribute_autoconditions.txt
	integration/config/plugins/integration-tests/data/tests/tests_flagship_model_condition.txt
	integration/config/plugins/integration-tests/data/tests/tests_flagship_planet_attribute.txt
	integration/config/plugins/integration-tests/data/tests/tests_framework.txt
	integration/config/plugins/integration-tests/data/tests/tests_hyperjumps_to_autocondition.txt
	integration/config/plugins/integration-tests/data/tests/tests_illegal_atrocity.txt
	integration/config/plugins/integration-tests/data/tests/tests_landing.txt
	integration/config/plugins/integration-tests/data/tests/tests_take_ships.txt
	integration/config/plugins/integration-tests/data/tests/tests_save_load.txt
	integration/config/plugins/integration-tests/data/tests/tests_ship_sale.txt
	integration/config/plugins/integration-tests/data/tests/tests_shipyard_outfitter_missions.txt
	integration/config/plugins/integration-tests/data/tests/tests_store_outfits_on_take_off.txt
	integration/config/plugins/integration-tests/data/tests/tests_to_accept.txt
	integration/config/plugins/integration-tests/data/tests/tests_wormhole_navigation.txt
	integration/config/plugins/integration-tests/data/tests/tests_installed_plugin.txt
)

target_include_directories(EndlessSkyTests PRIVATE unit/include)
target_link_libraries(EndlessSkyTests PRIVATE ExternalLibraries $<TARGET_OBJECTS:EndlessSkyLib>)

# CTest support for our unit tests.
add_test(NAME unit COMMAND EndlessSkyTests)
set_tests_properties(unit PROPERTIES WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}" LABELS unit)
add_test(NAME benchmark COMMAND "$<TARGET_FILE:EndlessSkyTests>" [!benchmark])
set_tests_properties(benchmark PROPERTIES WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}" LABELS benchmark)

# Integration tests.
add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/IntegrationTests_tests.cmake"
	COMMENT "Discover every integration test"
	COMMAND "${CMAKE_COMMAND}" -DES=$<TARGET_FILE:EndlessSky>
		-DBINARY_PATH=${CMAKE_CURRENT_BINARY_DIR}
		-DRESOURCE_PATH=${CMAKE_SOURCE_DIR}
		-DES_USE_OFFSCREEN=${ES_USE_OFFSCREEN}
		-P "${CMAKE_CURRENT_SOURCE_DIR}/integration/IntegrationTests.cmake"
	DEPENDS EndlessSky ${INTEGRATION_TESTS}
		"${CMAKE_CURRENT_SOURCE_DIR}/integration/IntegrationTests.cmake"
	WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}" VERBATIM)
set_property(DIRECTORY APPEND PROPERTY TEST_INCLUDE_FILES "${CMAKE_CURRENT_BINARY_DIR}/IntegrationTests_tests.cmake")
add_custom_target(IntegrationTests ALL
	DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/IntegrationTests_tests.cmake"
	VERBATIM
)

if(NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/IntegrationTests_tests.cmake")
	# If the target is not run, simply don't provide any integration tests instead of erroring out.
	file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/IntegrationTests_tests.cmake" "")
endif()

# Copy the MinGW runtime DLLs if necessary.
if(MINGW AND WIN32)
	foreach(FILE_PATH ${MINGW_RUNTIME})
		add_custom_command(TARGET EndlessSkyTests POST_BUILD
			COMMAND "${CMAKE_COMMAND}" -E copy_if_different "${FILE_PATH}" "$<TARGET_FILE_DIR:EndlessSkyTests>"
			COMMAND_EXPAND_LISTS VERBATIM)
	endforeach()
endif()

=== debian/changelog ===
endless-sky (0.10.6-1mx23+1) mx; urgency=medium

  * Rebuild for MX-23.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Fri, 01 Mar 2024 10:13:35 -0800

=== debian/control ===
Source: endless-sky
Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Damyan Ivanov <dmn@debian.org>
Section: games
Priority: optional
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/games-team/endless-sky
Vcs-Git: https://salsa.debian.org/games-team/endless-sky.git
Homepage: https://endless-sky.github.io
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 g++ (>=4.6),
 libgl-dev,
 libglew-dev,
 libjpeg-dev,
 libopenal-dev,
 libpng-dev,
 libsdl2-dev,
 libmad0-dev,
 ninja-build,
 scons,
 uuid-dev,
 xauth <!nocheck>,
 xvfb <!nocheck>

Package: endless-sky
Architecture: any
Depends:
 endless-sky-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: space exploration, trading and combat game
 Explore other star systems.
 .
 Earn money by trading, carrying passengers, or completing missions.
 Use your earnings to buy a better ship or to upgrade the weapons and engines
 on your current one.
 .
 Blow up pirates.
 Take sides in a civil war.
 Or leave human space behind and hope to find some friendly aliens whose
 culture is more civilized than your own...
 .
 Endless Sky is a sandbox-style space exploration game similar to Elite,
 Escape Velocity, or Star Control.
 You start out as the captain of a tiny spaceship and can choose what to do
 from there.
 The game includes a major plot line and many minor missions, but you can
 choose whether you want to play through the plot or strike out on your own as
 a merchant or bounty hunter or explorer.

Package: endless-sky-data
Architecture: all
Depends:
 ${misc:Depends}
Description: space exploration, trading and combat game - data files
 This package contains the architecture-independent data files for
 endless-sky.

## endless-sky 0.10.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,14 @@
-cmake_minimum_required(VERSION 3.21..3.25)
+cmake_minimum_required(VERSION 3.16...3.29)
 
 include(CMakeDependentOption)
-option(ES_USE_VCPKG "Use vcpkg to get dependencies." ON)
+if(UNIX AND NOT APPLE)
+	option(ES_USE_VCPKG "Use vcpkg to get dependencies." OFF)
+else()
+	option(ES_USE_VCPKG "Use vcpkg to get dependencies." ON)
+endif()
 cmake_dependent_option(ES_GLES "Build the game with OpenGL ES" OFF UNIX OFF)
-cmake_dependent_option(ES_FLATPAK "Build the game inside the Flatpak runtime" OFF UNIX OFF)
 cmake_dependent_option(ES_STEAM "Build the game for the Steam Linux runtime" OFF UNIX OFF)
-cmake_dependent_option(ES_USE_SYSTEM_LIBRARIES "Use system libraries instead of the vcpkg ones." ON UNIX OFF)
+cmake_dependent_option(ES_USE_SYSTEM_LIBRARIES "Use system libraries instead of the vcpkg ones." ON APPLE OFF)
 cmake_dependent_option(ES_CREATE_BUNDLE "Create a Bundle instead of an executable. Not suitable for development purposes." OFF APPLE OFF)
 
 # Support Debug and Release configurations.
@@ -42,13 +45,9 @@
 	list(APPEND VCPKG_MANIFEST_FEATURES "system-libs")
 endif()
 
-# Tell vcpkg to use system libraries that are missing on the respective platform.
-if(ES_FLATPAK)
-	list(APPEND VCPKG_MANIFEST_FEATURES "flatpak-libs")
-elseif(ES_STEAM)
+# Tell vcpkg to use system libraries that are missing in the Steam runtime.
+if(ES_STEAM)
 	list(APPEND VCPKG_MANIFEST_FEATURES "steam-libs")
-elseif(APPLE)
-	list(APPEND VCPKG_MANIFEST_FEATURES "macos-libs")
 endif()
 
 # Various helpful options for IDEs.
@@ -56,7 +55,7 @@
 set_property(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT EndlessSky)
 set(CMAKE_VS_JUST_MY_CODE_DEBUGGING ON)
 
-project("Endless Sky" VERSION 0.10.6
+project("Endless Sky" VERSION 0.10.7
 	DESCRIPTION "Space exploration, trading, and combat game."
 	HOMEPAGE_URL https://endless-sky.github.io/
 	LANGUAGES CXX)
@@ -133,7 +132,7 @@
 		find_path(UUID_INCLUDE uuid/uuid.h /usr/local/include /usr/include)
 		target_link_libraries(ExternalLibraries INTERFACE "${UUID_LIB}")
 		target_include_directories(ExternalLibraries INTERFACE "${UUID_INCLUDE}")
-	elseif(ES_USE_SYSTEM_LIBRARIES)
+	elseif(NOT ES_USE_VCPKG OR ES_USE_SYSTEM_LIBRARIES)
 		find_library(UUID_LIB uuid)
 		target_link_libraries(ExternalLibraries INTERFACE "${UUID_LIB}")
 	else()
@@ -161,7 +160,7 @@
 		target_compile_definitions(EndlessSkyLib PUBLIC GL_SILENCE_DEPRECATION)
 	else()
 		# GLEW is only needed on Linux and Windows.
-		target_link_libraries(ExternalLibraries INTERFACE GLEW::GLEW)
+		target_link_libraries(ExternalLibraries INTERFACE GLEW::glew)
 	endif()
 endif()
 
@@ -291,3 +290,5 @@
 	install(FILES keys.txt DESTINATION share/games/endless-sky)
 	install(FILES copyright DESTINATION share/doc/endless-sky)
 	install(FILES changelog DESTINATION share/doc/endless-sky)
+	install(FILES license.txt DESTINATION share/doc/endless-sky)
+endif()

=== source/CMakeLists.txt ===
--- 
+++ 
@@ -303,8 +303,6 @@
 	SpaceportPanel.h
 	Sprite.cpp
 	Sprite.h
-	SpriteQueue.cpp
-	SpriteQueue.h
 	SpriteSet.cpp
 	SpriteSet.h
 	SpriteShader.cpp
@@ -320,6 +318,8 @@
 	System.cpp
 	System.h
 	SystemEntry.h
+	TaskQueue.cpp
+	TaskQueue.h
 	Test.cpp
 	Test.h
 	TestContext.cpp

=== debian/changelog ===
endless-sky (0.10.7-1mx23+1) mx; urgency=medium

  * Rebuild for MX-23.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Fri, 14 Jun 2024 15:46:57 -0700

## endless-sky 0.10.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,14 @@
 cmake_minimum_required(VERSION 3.16...3.29)
 
 include(CMakeDependentOption)
-if(UNIX AND NOT APPLE)
+if(UNIX AND NOT APPLE AND NOT ES_STEAM)
 	option(ES_USE_VCPKG "Use vcpkg to get dependencies." OFF)
 else()
 	option(ES_USE_VCPKG "Use vcpkg to get dependencies." ON)
 endif()
 cmake_dependent_option(ES_GLES "Build the game with OpenGL ES" OFF UNIX OFF)
 cmake_dependent_option(ES_STEAM "Build the game for the Steam Linux runtime" OFF UNIX OFF)
-cmake_dependent_option(ES_USE_SYSTEM_LIBRARIES "Use system libraries instead of the vcpkg ones." ON APPLE OFF)
+cmake_dependent_option(ES_USE_SYSTEM_LIBRARIES "Use system libraries instead of the vcpkg ones." ON "APPLE OR ES_STEAM" OFF)
 cmake_dependent_option(ES_CREATE_BUNDLE "Create a Bundle instead of an executable. Not suitable for development purposes." OFF APPLE OFF)
 
 # Support Debug and Release configurations.
@@ -55,7 +55,7 @@
 set_property(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT EndlessSky)
 set(CMAKE_VS_JUST_MY_CODE_DEBUGGING ON)
 
-project("Endless Sky" VERSION 0.10.7
+project("Endless Sky" VERSION 0.10.8
 	DESCRIPTION "Space exploration, trading, and combat game."
 	HOMEPAGE_URL https://endless-sky.github.io/
 	LANGUAGES CXX)

=== SConstruct ===
import os
import platform
from SCons.Node.FS import Dir
from SCons.Errors import SConsEnvironmentError
from SCons.Defaults import DefaultEnvironment

def pathjoin(*args):
	return os.path.join(*args)

# Load environment variables, including some that should be renamed.
# If we are compiling on Windows, then we need to change the toolset to MinGW.
is_windows_host = platform.system().startswith('Windows')
scons_toolset = ['mingw' if is_windows_host else 'default']
env = DefaultEnvironment(tools = scons_toolset, ENV = os.environ, COMPILATIONDB_USE_ABSPATH=True)
# If manually building within the Steam Runtime (scout), SCons will need to be invoked directly
# with `python3.5`. Most other runtimes / build hosts will default to a newer version of python.
env.EnsurePythonVersion(3, 5)
# Make sure the current SCons version is at least v3.1.0; newer versions are allowed.
env.EnsureSConsVersion(3, 1, 0)

try:
    env.Tool('compilation_db')
    env.Default(env.CompilationDatabase())
# scons before 4.0.0 is used. In that case, simply don't provide a compilation database.
except SConsEnvironmentError:
    pass

if 'CXX' in os.environ:
	env['CXX'] = os.environ['CXX']
if 'CXXFLAGS' in os.environ:
	env.Append(CCFLAGS = os.environ['CXXFLAGS'])
if 'CPPFLAGS' in os.environ:
	env.Append(CCFLAGS = os.environ['CPPFLAGS'])
if 'LDFLAGS' in os.environ:
	env.Append(LINKFLAGS = os.environ['LDFLAGS'])
if 'AR' in os.environ:
	env['AR'] = os.environ['AR']
if 'DIR_ESLIB' in os.environ:
	path = os.environ['DIR_ESLIB']
	env.Prepend(CPPPATH = [pathjoin(path, 'include')])
	env.Append(LIBPATH = [pathjoin(path, 'lib')])

# Don't spawn a console window by default on Windows builds.
if is_windows_host:
	env.Append(LINKFLAGS = ["-mwindows"])

opts = Variables()
opts.AddVariables(
	EnumVariable("mode", "Compilation mode", "release", allowed_values=("release", "debug", "profile")),
	EnumVariable("opengl", "Whether to use OpenGL or OpenGL ES", "desktop", allowed_values=("desktop", "gles")),
	PathVariable("BUILDDIR", "Directory to store compiled object files in", "build", PathVariable.PathIsDirCreate),
	PathVariable("BIN_DIR", "Directory to store binaries in", ".", PathVariable.PathIsDirCreate),
	PathVariable("DESTDIR", "Destination root directory, e.g. if building a package", "", PathVariable.PathAccept),
	PathVariable("PREFIX", "Directory to install under (will be prefixed by DESTDIR)", "/usr/local", PathVariable.PathIsDirCreate),
)
opts.Update(env)
Help(opts.GenerateHelpText(env))

# Required build flags. To enable SSE or other optimizations, pass CXXFLAGS via the environment
#   $ CXXFLAGS=-msse3 scons
#   $ CXXFLAGS=-march=native scons
# or modify the `flags` variable:
flags = ["-std=c++17", "-Wall", "-pedantic-errors", "-Wold-style-cast", "-fno-rtti"]
if env["mode"] != "debug":
	flags += ["-Werror", "-O3", "-flto"]
	env.Append(LINKFLAGS = ["-O3", "-flto"])
if env["mode"] == "debug":
	flags += ["-g"]
elif env["mode"] == "profile":
	flags += ["-pg"]
	env.Append(LINKFLAGS = ["-pg"])
env.Append(CCFLAGS = flags)

# Always use `ar` to create the symbol table, and don't use ranlib at all, since it fails to preserve
# LTO information, even when passed the plugin path, when run in Steam's "Scout" runtime.
env['RANLIBCOM'] = ''
# TODO: can we derive thin archive support from the host system somehow? Or just always use it?
create_thin_archives = env.get('AR', '').startswith('gcc')
env.Replace(ARFLAGS = 'rcsT' if create_thin_archives else 'rcs')

# The Steam runtime fails to correctly invoke the LTO plugin for gcc-5, so pass it explicitly
chroot_name = os.environ.get('SCHROOT_CHROOT_NAME', '')
if 'steamrt_scout' in chroot_name:
	# MAYBE: read g++ version to determine correct path to the LTO plugin
	plugin_path = '--plugin={}'.format(os.environ.get('LTO_PLUGIN_PATH', '/usr/lib/gcc/x86_64-linux-gnu/5/liblto_plugin.so'))
	env.Append(ARFLAGS = [plugin_path])

# Required system libraries, such as UUID generator runtimes.
sys_libs = [
	"rpcrt4",
] if is_windows_host else [
	"uuid"
]
env.Append(LIBS = sys_libs)

game_libs = [
	"winmm",
	"mingw32",
	"sdl2main",
	"sdl2.dll",
	"png.dll",
	"turbojpeg.dll",
	"jpeg.dll",
	"openal32.dll",
] if is_windows_host else [
	"SDL2",
	"png",
	"jpeg",
	"openal",
	"pthread",
]
env.Append(LIBS = game_libs)

if env["opengl"] == "gles":
	if is_windows_host:
		print("OpenGL ES builds are not supported on Windows")
		Exit(1)
	env.Append(LIBS = [
		"OpenGL",
	])
	env.Append(CCFLAGS = ["-DES_GLES"])
elif is_windows_host:
	env.Append(LIBS = [
		"glew32.dll",
		"opengl32",
	])
else:
	env.Append(LIBS = [
		"GL" if 'steamrt_scout' in chroot_name else "OpenGL",
		"GLEW",
	])

# libmad is not in the Steam runtime, so link it statically:
if 'steamrt_scout_i386' in chroot_name:
	env.Append(LIBS = File("/usr/lib/i386-linux-gnu/libmad.a"))
elif 'steamrt_scout_amd64' in chroot_name:
	env.Append(LIBS = File("/usr/lib/x86_64-linux-gnu/libmad.a"))
else:
	env.Append(LIBS = "mad")


binDirectory = '' if env["BIN_DIR"] == '.' else pathjoin(env["BIN_DIR"], env["mode"])
buildDirectory = pathjoin(env["BUILDDIR"], env["mode"])
libDirectory = pathjoin("lib", env["mode"])
env.VariantDir(buildDirectory, "source", duplicate = 0)

# Find all regular source files.
def RecursiveGlob(pattern, dir_name=buildDirectory):
	# Start with source files in subdirectories.
	matches = [RecursiveGlob(pattern, sub_dir) for sub_dir in env.Glob(pathjoin(str(dir_name), "*"))
		if isinstance(sub_dir, Dir)]
	# Add source files in this directory, except for main.cpp
	matches += env.Glob(pathjoin(str(dir_name), pattern))
	matches = [i for i in matches if not '{}main.cpp'.format(os.path.sep) in str(i)]
	return matches

# By default, invoking scons will build the backing archive file and then the game binary.
sourceLib = env.StaticLibrary(pathjoin(libDirectory, "endless-sky"), RecursiveGlob("*.cpp", buildDirectory))
exeObjs = [env.Glob(pathjoin(buildDirectory, f)) for f in ("main.cpp",)]
if is_windows_host:
	windows_icon = env.RES(pathjoin(buildDirectory, "WinApp.rc"))
	exeObjs.append(windows_icon)
sky = env.Program(pathjoin(binDirectory, "endless-sky"), exeObjs + sourceLib)
env.Default(sky)


# The testing infrastructure ignores "mode" specification (i.e. we only test optimized output).
# (If we add support for code coverage output, this will likely need to change.)
testBuildDirectory = pathjoin("tests", "unit", env["BUILDDIR"])
env.VariantDir(testBuildDirectory, pathjoin("tests", "unit", "src"), duplicate = 0)
test = env.Program(
	target=pathjoin("tests", "unit", "endless-sky-tests"),
	source=RecursiveGlob("*.cpp", testBuildDirectory) + sourceLib,
	# Add Catch header & additional test includes to the existing search paths.
	CPPPATH=(env.get('CPPPATH', []) + [pathjoin('tests', 'unit', 'include')]),
	# Do not link against the actual implementations of SDL, OpenGL, etc.
	LIBS=sys_libs,
	# Pass the necessary link flags for a console program.
	LINKFLAGS=[x for x in env.get('LINKFLAGS', []) if x not in ('-mwindows',)]
)
# Invoking scons with the `build-tests` target will build the unit test framework
env.Alias("build-tests", test)
# Invoking scons with the `test` target will build (if necessary) and
# execute the unit test framework (always). All non-hidden tests are run.
catch2_args = " " + " ".join([
	"-i",
	"--warn NoAssertions",
	"--order rand",
	"--rng-seed 'time'",
])
test_runner = env.Action(test[0].abspath + catch2_args, 'Running tests...')
env.Alias("test", test, test_runner)
env.AlwaysBuild("test")


# Install the binary:
env.Install("$DESTDIR$PREFIX/games", sky)

# Install the desktop file:
env.Install("$DESTDIR$PREFIX/share/applications", "io.github.endless_sky.endless_sky.desktop")

# Install app center metadata:
env.Install("$DESTDIR$PREFIX/share/metainfo", "io.github.endless_sky.endless_sky.appdata.xml")

# Install icons, keeping track of all the paths.
# Most Ubuntu apps supply 16, 22, 24, 32, 48, and 256, and sometimes others.
sizes = ["16x16", "22x22", "24x24", "32x32", "48x48", "128x128", "256x256", "512x512"]
icons = []
for size in sizes:
	destination = "$DESTDIR$PREFIX/share/icons/hicolor/" + size + "/apps/endless-sky.png"
	icons.append(destination)
	env.InstallAs(destination, "icons/icon_" + size + ".png")

# If any of those icons changed, also update the cache.
# Do not update the cache if we're not installing into "usr".
# (For example, this "install" may actually be creating a Debian package.)
if env.get("PREFIX").startswith("/usr/"):
	env.Command(
		[],
		icons,
		"gtk-update-icon-cache -t $DESTDIR$PREFIX/share/icons/hicolor/")

# Install the man page.
env.Command(
	"$DESTDIR$PREFIX/share/man/man6/endless-sky.6.gz",
	"endless-sky.6",
	"gzip -c $SOURCE > $TARGET")

# Install the data files.
def RecursiveInstall(env, target, source):
	rootIndex = len(env.Dir(source).abspath) + 1
	for node in env.Glob(pathjoin(source, '*')):
		if node.isdir():
			name = node.abspath[rootIndex:]
			RecursiveInstall(env, pathjoin(target, name), node.abspath)
		else:
			env.Install(target, node)
RecursiveInstall(env, "$DESTDIR$PREFIX/share/games/endless-sky/data", "data")
RecursiveInstall(env, "$DESTDIR$PREFIX/share/games/endless-sky/images", "images")
RecursiveInstall(env, "$DESTDIR$PREFIX/share/games/endless-sky/sounds", "sounds")
env.Install("$DESTDIR$PREFIX/share/games/endless-sky", "credits.txt")
env.Install("$DESTDIR$PREFIX/share/games/endless-sky", "keys.txt")

# Make the word "install" in the command line do an installation.
env.Alias("install", "$DESTDIR$PREFIX")

=== source/CMakeLists.txt ===
--- 
+++ 
@@ -104,6 +104,7 @@
 	EscortDisplay.cpp
 	EscortDisplay.h
 	ExclusiveItem.h
+	FighterHitHelper.h
 	File.cpp
 	File.h
 	Files.cpp

=== debian/changelog ===
endless-sky (0.10.8-1mx23+1) mx; urgency=medium

  * Rebuild for MX-23.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sun, 23 Jun 2024 11:25:54 -0700

=== debian/control ===
--- 
+++ 
@@ -20,8 +20,6 @@
  libsdl2-dev,
  libmad0-dev,
  ninja-build,
- scons,
- uuid-dev,
  xauth <!nocheck>,
  xvfb <!nocheck>
